// ⺻ DLL Դϴ.

#include "stdafx.h"
#include <msclr\marshal_cppstd.h>
using namespace msclr::interop;

#include "NetworkFacade.h"
#include "ProactorFactory.h"
#include "MessageHeader.h"
#include "SimpleConfig.h"
using namespace HalfNetwork;

#include "HalfNetwork_NET.h"
#include "ErrorCode.h"

namespace HalfNetwork_NET 
{
	HalfNetworkNET::HalfNetworkNET()
	{
		Init_ACE();

		m_nMaxClientCount = 0;
	}

	HalfNetworkNET::~HalfNetworkNET()
	{
		End_ACE();
	}

	void HalfNetworkNET::Init()
	{
		m_Network = gcnew ServerNetwork();
	}

	void HalfNetworkNET::Init_ACE()
	{
		/// Ϲ  ȣϸ   ȵȴ. !!!
		ACE::init();
	}

	void HalfNetworkNET::End_ACE()
	{
		ACE::fini();
	}

	bool HalfNetworkNET::Run()
	{
		Update();
		return true;
	}

	bool HalfNetworkNET::End()
	{
		AwakeHFNPopMessage();
		Close();
		return true;
	}

	void HalfNetworkNET::AwakeHFNPopMessage()
	{
		// NetworkFacadeInstance->PopAllMessage  QueueID  Ǵ ޼ ⿡
		//   ÿ  ̰ ȣؾ Ѵ.
		NetworkInstance->Pulse();
	}

	short HalfNetworkNET::Open()
	{
		SimpleConfig configReader;
		if( false == configReader.ReadFile( CONFIG_FILE_NAME ) ) {
			return ERRORCODE::SERVER_FAILED_CONFIGFILE;
		}
	
		// 2010.07.15 
		// HalfNetwork::eSM_Interval   config.Interval_Send_Term 20 ̻   Ѵ.
		//  20 ߱  Ʈ   20 и  Ŀ Žȴ.
		HalfNetwork::SystemConfig config;
		config.Worker_Thread_Count = configReader.GetValue<unsigned char>(ACE_TEXT("workerthread"));
		config.Receive_Buffer_Len = 2048;
		config.Interval_Send_Term = configReader.GetValue<unsigned int>(ACE_TEXT("updateterm"));
		config.Send_Mode = HalfNetwork::eSM_Direct;
		config.ZombieConnectionTerm = 0;

		UINT16 ServerPort = configReader.GetValue<UINT16>(ACE_TEXT("server_port"));
		UINT16 ClientPort = configReader.GetValue<UINT16>(ACE_TEXT("client_port"));
		UINT32 ServerBuffSize = configReader.GetValue<UINT16>(ACE_TEXT("server_receive_buff_size"));
		UINT32 ClientBuffSize = configReader.GetValue<UINT16>(ACE_TEXT("client_receive_buff_size"));
		m_nMaxClientCount = configReader.GetValue<UINT16>(ACE_TEXT("client_init_accept_count"));
	
		if( false == NetworkInstance->Create<HalfNetwork::ProactorFactory>() ) {
			return ERRORCODE::CREATE_PROACTORFACTORY;
		}
	
		if( ClientPort > 0 )
		{
			if( false == NetworkInstance->AddAcceptor(NULL, ClientPort, CLIENT_QUEUE_ID, ClientBuffSize, m_nMaxClientCount ) ) {
				return ERRORCODE::CLIENT_ADDACCEPTOR;
			}
		}
	
		if( ServerPort > 0 )
		{
			if( false == NetworkInstance->AddAcceptor(NULL, ServerPort, SERVER_QUEUE_ID, ServerBuffSize) ) {
				return ERRORCODE::SERVER_ADDACCEPTOR;
			}
		}

		// config   ũ ٴ AddAccept   켱 Ѵ.
		if( false == NetworkInstance->Open(&config) ) {
			return ERRORCODE::SERVER_OPEN;
		}

		return ERRORCODE::NONE;
	}

	void HalfNetworkNET::Close()
	{
		NetworkInstance->Close();
		NetworkInstance->Destroy();
	}

	void HalfNetworkNET::Update()
	{
		ProcessRecvQueue();
	}

	void HalfNetworkNET::ProcessRecvQueue()
	{
		ACE_Message_Block* headBlock = NULL;
		ACE_Message_Block* commandBlock = NULL;
    
		bool popResult = NetworkInstance->PopAllMessage( &headBlock, -1 );
		if (false == popResult) {
			return;
		}

		commandBlock = headBlock;
		while(NULL != commandBlock)
		{
			MessagePostee postee;
			memcpy(&postee, commandBlock->rd_ptr(), sizeof(MessagePostee));
			commandBlock->rd_ptr(sizeof(MessagePostee));
			ACE_Message_Block* payloadBlock = commandBlock->cont();

			array< Byte >^ byteArray = gcnew array< Byte >(payloadBlock->length());
			if( 0 < payloadBlock->length() ) { 
				System::Runtime::InteropServices::Marshal::Copy((IntPtr)payloadBlock->rd_ptr(),byteArray, 0, payloadBlock->length() );
			}
			
			if( CLIENT_QUEUE_ID == postee.queue_id )
			{
				ProcessRecvQueueClient( postee.command, postee.stream_id, byteArray );
			}
			else if( SERVER_QUEUE_ID == postee.queue_id )
			{
				ProcessRecvQueueServer( postee.command, postee.stream_id, byteArray );
			}
		
			commandBlock = payloadBlock->cont();
		}
		headBlock->release();
	}

	void HalfNetworkNET::ProcessRecvQueueClient( const INT32 MsgType, const unsigned int StreamID, array<Byte>^ RecvData )
	{
		switch(MsgType)
		{
		case eMH_Establish:
			{
				String^ IP = System::Text::Encoding::ASCII->GetString(RecvData);
				OnAccept_Client( StreamID, IP );
			}
			break;
		case eMH_Read:
			OnRead_Client( StreamID, RecvData );
			break;
		case eMH_Close:
			OnDisConnect_Client( StreamID );
			break;
		}
	}

	void HalfNetworkNET::ProcessRecvQueueServer( INT32 MsgType, unsigned int StreamID, array<Byte>^ RecvData )
	{
		switch(MsgType)
		{
		case eMH_Establish:
			{
				String^ IP = System::Text::Encoding::ASCII->GetString(RecvData);
				OnAccept_Server( StreamID, IP );
			}
			break;
		case eMH_Read:
			OnRead_Server( StreamID, RecvData );
			break;
		case eMH_Close:
			OnDisConnect_Server( StreamID );
			break;
		case eMH_Custom:
			OnRead_Server( StreamID, RecvData );
			break;
		}
	}
}