// HalfNetwork_NET.h
#pragma once


using namespace System;

#include "ServerNetwork.h"


namespace HalfNetwork_NET 
{
	public ref class HalfNetworkNET abstract
	{
	public:
		HalfNetworkNET();
		virtual ~HalfNetworkNET();

		virtual bool Run();
		virtual bool End();

		virtual void Init();
		virtual short	Open();
		virtual void	Close();
		
		ServerNetwork^ GetNetwork() { return m_Network; }



	protected:
		static void Init_ACE();
		static void End_ACE();
		
		virtual void OnAccept_Client( unsigned int StreamID, String^ IP ) abstract;
		virtual void OnRead_Client( unsigned int StreamID, array<Byte>^ RecvData ) abstract;
		virtual void OnDisConnect_Client( unsigned int StreamID ) abstract;
		 
		virtual void OnAccept_Server( unsigned int StreamID, String^ IP ) abstract;
		virtual void OnRead_Server( unsigned int StreamID, array<Byte>^ RecvData ) abstract;
		virtual void OnDisConnect_Server( unsigned int StreamID ) abstract;

		virtual void	Update();
		void ProcessRecvQueue();
		void ProcessRecvQueueClient( const INT32 MsgType, const unsigned int StreamID, array<Byte>^ RecvData );
		void ProcessRecvQueueServer( const INT32 MsgType, const unsigned int StreamID, array<Byte>^ RecvData );
		
		void AwakeHFNPopMessage();


		ServerNetwork^ m_Network;
		int m_nMaxClientCount;
	};
}
